#ifndef EFL_GENERATED_ECORE_AUDIO_IN_TONE_HH
#define EFL_GENERATED_ECORE_AUDIO_IN_TONE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio_in_tone.eo.h"
}

#include "ecore_audio_in.eo.hh"
#include <string>

struct ecore_audio_in_tone
      : ecore_audio_in
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_in_tone(Eo* eo)
      : ecore_audio_in(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio_in_tone(std::nullptr_t)
      : ecore_audio_in(nullptr)
   {}

   /// @brief Call the object's constructor.
   /// Should not be used with #eo_do. Only use it with #eo_do_super.
   ///
   ecore_audio_in_tone(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : ecore_audio_in_tone(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_in_tone(ecore_audio_in_tone const& other)
      : ecore_audio_in(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_in_tone() {}

   /// @brief Set generic data to object.
   ///
   /// @param key the key associated with the data
   /// @param data the data to set
   /// @param free_func the func to free data with (NULL means
   ///
   void key_data_set(std::string key_, const void * data_, eo_key_data_free_func free_func_) const
   {
      eo_do(_eo_ptr(), ::eo_key_data_set(efl::eolian::to_c(key_), data_, free_func_));
   }

   /// @brief Get generic data from object.
   ///
   /// @param key the key associated with the data
   ///
   void * key_data_get(std::string key_) const
   {
      void * _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::eo_key_data_get(efl::eolian::to_c(key_)));
      return _tmp_ret;
   }

   /// @brief Set the length of the input
   ///
   /// This function is only implemented by some classes
   /// (i.e. ECORE_AUDIO_OBJ_IN_TONE_CLASS)
   ///
   /// @since 1.8
   ///
   /// @param length 
   ///
   void length_set(double length_) const
   {
      eo_do(_eo_ptr(), ::ecore_audio_obj_in_length_set(length_));
   }

   /// @brief Seek within the input
   ///
   /// @since 1.8
   ///
   /// @param offs 
   /// @param mode 
   ///
   double seek(double offs_, int mode_) const
   {
      double _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_seek(offs_, mode_));
      return _tmp_ret;
   }

   /// @brief Internal read function
   ///
   /// @since 1.8
   ///
   /// @param buf 
   /// @param len 
   ///
   ssize_t read_internal(void * buf_, size_t len_) const
   {
      ssize_t _tmp_ret;
      eo_do(_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
      return _tmp_ret;
   }

   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_IN_TONE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_ref(ECORE_AUDIO_IN_TONE_CLASS, _p._eo_raw, eo_constructor());
   }

};
template <typename T>
void _ecore_audio_in_tone_key_data_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * key_, const void * data_, eo_key_data_free_func free_func_)
{
   static_cast<T*>(self->this_)->key_data_set(efl::eolian::to_cxx<std::string>(key_, std::tuple<std::false_type>()), data_, free_func_);
}

template <typename T>
void * _ecore_audio_in_tone_key_data_get_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, const char * key_)
{
   return static_cast<T*>(self->this_)->key_data_get(efl::eolian::to_cxx<std::string>(key_, std::tuple<std::false_type>()));
}

template <typename T>
void _ecore_audio_in_tone_length_set_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double length_)
{
   static_cast<T*>(self->this_)->length_set(length_);
}

template <typename T>
double _ecore_audio_in_tone_seek_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, double offs_, int mode_)
{
   return static_cast<T*>(self->this_)->seek(offs_, mode_);
}

template <typename T>
ssize_t _ecore_audio_in_tone_read_internal_wrapper(Eo* objid EINA_UNUSED, efl::eo::detail::Inherit_Private_Data* self, void * buf_, size_t len_)
{
   return static_cast<T*>(self->this_)->read_internal(buf_, len_);
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_in_tone >
{
   template <typename T>
   struct type
   {
      virtual void key_data_set(std::string key_, const void * data_, eo_key_data_free_func free_func_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::eo_key_data_set(efl::eolian::to_c(key_), data_, free_func_));
      }

      virtual void * key_data_get(std::string key_)
      {
         void * _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::eo_key_data_get(efl::eolian::to_c(key_)));
            return _tmp_ret;
      }

      virtual void length_set(double length_)
      {
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               ::ecore_audio_obj_in_length_set(length_));
      }

      virtual double seek(double offs_, int mode_)
      {
         double _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_seek(offs_, mode_));
            return _tmp_ret;
      }

      virtual ssize_t read_internal(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do_super(static_cast<T*>(this)->_eo_ptr(),
               static_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
            return _tmp_ret;
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio_in_tone >
{
   static const int value = 5;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_audio_in_tone>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_ecore_audio_in_tone_key_data_set_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::eo_key_data_set);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_ecore_audio_in_tone_key_data_get_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::eo_key_data_get);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_ecore_audio_in_tone_length_set_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_length_set);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   ops[3].func = reinterpret_cast<void*>(& ::_ecore_audio_in_tone_seek_wrapper<T>);
   ops[3].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_seek);
   ops[3].op = EO_OP_OVERRIDE;
   ops[3].op_type = EO_OP_TYPE_REGULAR;
   ops[3].doc = NULL;

   ops[4].func = reinterpret_cast<void*>(& ::_ecore_audio_in_tone_read_internal_wrapper<T>);
   ops[4].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_in_read_internal);
   ops[4].op = EO_OP_OVERRIDE;
   ops[4].op_type = EO_OP_TYPE_REGULAR;
   ops[4].doc = NULL;

   return 0;
}
inline void
call_constructor(tag< ::ecore_audio_in_tone >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_in_tone, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< ::ecore_audio_in_tone >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<::ecore_audio_in_tone, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< ::ecore_audio_in_tone>
{
   template <typename U>
   struct type
   {
      operator ::ecore_audio_in_tone() const
      {
         return ::ecore_audio_in_tone(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

      void key_data_set(std::string key_, const void * data_, eo_key_data_free_func free_func_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::eo_key_data_set(efl::eolian::to_c(key_), data_, free_func_));
      }

      void * key_data_get(std::string key_)
      {
         void * _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::eo_key_data_get(efl::eolian::to_c(key_)));
            return _tmp_ret;
      }

      void length_set(double length_)
      {
         eo_do(static_cast<U*>(this)->_eo_ptr(), ::ecore_audio_obj_in_length_set(length_));
      }

      double seek(double offs_, int mode_)
      {
         double _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_seek(offs_, mode_));
            return _tmp_ret;
      }

      ssize_t read_internal(void * buf_, size_t len_)
      {
         ssize_t _tmp_ret = {};
         eo_do(static_cast<U*>(this)->_eo_ptr(), _tmp_ret = ::ecore_audio_obj_in_read_internal(buf_, len_));
            return _tmp_ret;
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_audio_in_tone>)
{
   return (ECORE_AUDIO_IN_TONE_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_IN_TONE_HH

